function AICYCommandHandler()
{
	BaseCommandHandler.call(this);
};

AICYCommandHandler.prototype = Object.create(BaseCommandHandler.prototype);

AICYCommandHandler.prototype.constructor = AICYCommandHandler;

AICYCommandHandler.prototype._doOpenArticle = function(id) {
	var openEvent = new CSEvent("com.Miles33.GN4.openArticle", "APPLICATION", csInterface.getApplicationID(), csInterface.getApplicationID());
	openEvent.data = "<gn4 id=\"" + id + "\" display=\"true\"></gn4>";
	csInterface.dispatchEvent(openEvent);
};

AICYCommandHandler.prototype._doOpenExtDoc = function(id, article, jump) {
	var data = "<gn4 id=\"" + id + "\" checkout=\"false\" upgradeDocument=\"false\">";
		
	if ( article != undefined && article.length > 0 ){
		data+="<article id=\"" + article + "\" place=\"false\"></article>";
	}
	
	if ( jump != undefined && jump.length > 0 ){
		data+="<jump id=\"" + jump + "\"></jump>";
	}
	
	data+="</gn4>";
	
	
	var openEvent = new CSEvent("com.Miles33.GN4.open", "APPLICATION", csInterface.getApplicationID(), csInterface.getApplicationID());
	openEvent.data = data;
	csInterface.dispatchEvent(openEvent);
};

AICYCommandHandler.prototype._openExtDocIds = function(folderObject) {
	var self = this;
	var articleId = folderObject.attr('id');
	var id = folderObject.attr('firstLinkedId');
	folderObject.attr('linkedIds').split(',').forEach(function (entry) {
		if ( entry != id){
			self._doOpenExtDoc(entry, articleId);
		}
	});
};


AICYCommandHandler.prototype.openFromI4 = function(ids, format) {
	var self = this;
	var url = getBaseURL() + "do.ashx?cmd=feed&name=AdobeI4Plugin&ids=";
	url += ids;
	url+="&random=" + guid();
	$.ajax({
	   type: "GET",
        url: url
      }).done(function (data) {
    	  $(data).find('objects folderObject').each(function(){
	    	  var objectType = $(this).attr('type');
	    	  var firstLinkedId = $(this).attr('firstLinkedId');
	    	  var id = $(this).attr('id');
	    	  switch(objectType) {
		    	  case "article":{
		    		  if (firstLinkedId != undefined && firstLinkedId.length > 0 ){
		    			  self._doOpenExtDoc(firstLinkedId, id);
		        		  self._openExtDocIds($(this));
		    		  } else {
		    			  self._doOpenArticle(id);
		    		  }
		    		  break;
		    	  }
		    	  
		    	  case "extDocJumpPart":{
		    		  if (firstLinkedId != undefined && firstLinkedId.length > 0 ){
	    				  self._doOpenExtDoc(firstLinkedId, "", id);
		    		  } else {
		    			  alert(resourceBundle.ItemNotLinkedOpenError.replace("{0}", $(this).attr('name')));
		    		  }
		    		  break;
		    	  }
	    	  }
    	  });
    	  $(data).find('objects extDoc').each(function(){
    		  self._doOpenExtDoc($(this).attr('id'));
    	  });
  
      }).fail(function (xhr) {
    	  alert(parseException(xhr));
      });

};
