function IDSNCommandHandler()
{
	BaseCommandHandler.call(this);
};

IDSNCommandHandler.prototype = Object.create(BaseCommandHandler.prototype);

IDSNCommandHandler.prototype.constructor = IDSNCommandHandler;

IDSNCommandHandler.prototype.openFromI4 = function(ids, format) {
	var self = this;
	ids.forEach(function (entry) {
		self._doOpen(entry);
	});
};

IDSNCommandHandler.prototype._doOpen = function(id, checkout, upgradeDocument, article, doPlace, jump, txtId) {
		var data = "<gn4 id=\"" + id + "\"";
		
		if ( checkout == undefined )
		{
			checkout = true;
		}
		data+= " checkout=\"" + checkout.toString() + "\"";
		if ( upgradeDocument == undefined )
		{
			upgradeDocument = false;
		}

		data+=" upgradeDocument=\"" + upgradeDocument.toString() + "\">";
			
		if ( article != undefined && article.length > 0 ){
			data+="<article id=\"" + article + "\" place=\"" + doPlace.toString() + "\"";
			if ( txtId!= undefined && article.length > 0 ){
				data+=" txtId=\"" + txtId + "\"";
			}
			data+="></article>";
		}
		
		if ( jump != undefined && jump.length > 0 ){
			data+="<jump id=\"" + jump + "\"></jump>";
		}
		
		data+="</gn4>";
		
		
		var openEvent = new CSEvent("com.Miles33.GN4.open", "APPLICATION", csInterface.getApplicationID(), csInterface.getApplicationID());
		openEvent.data = data;
		csInterface.dispatchEvent(openEvent);
};

IDSNCommandHandler.prototype._openIds = function(folderObject) {
	var self = this;
	var articleId = folderObject.attr('id');
	var id = folderObject.attr('firstLinkedId');
	folderObject.attr('linkedIds').split(',').forEach(function (entry) {
		if ( entry != id){
			self._doOpen(entry, false, false, articleId, false);
		}
	});
};


IDSNCommandHandler.prototype._doPlace = function(id, csEvent, folderId, txtId){
	var data = "<gn4 id=\"" + id + "\"";
	if ( folderId != undefined) {
		data += " folderId=\"" + folderId + "\"";
	}
	if ( txtId != undefined) {
		data += " txtId=\"" + txtId + "\"";
	}
	data +="></gn4>";
	var openEvent = new CSEvent(csEvent, "APPLICATION", csInterface.getApplicationID(), csInterface.getApplicationID());
	openEvent.data = data;
	csInterface.dispatchEvent(openEvent);
};

IDSNCommandHandler.prototype.placeFromI4 = function(event) {
	var self = this;
	var inSelectedBoxes = false;
	var csEvent = "com.Miles33.GN4.loadPlaceGun";
	if ( event.data.inSelectedBoxes != undefined && event.data.inSelectedBoxes.toString().toLowerCase() == "true" ){
		csEvent = "com.Miles33.GN4.place";
		inSelectedBoxes = true;
	}
	var url = getBaseURL() + "do.ashx?cmd=feed&name=AdobeI4Plugin&ids=";
	url += event.data.id;
	url+="&random=" + guid();
	$.ajax({
	   type: "GET",
        url: url
      }).done(function (data) {
    	  var $folderObject = $(data).find('objects folderObject');
    	  var objectType = $folderObject.attr('type');
    	  var firstLinkedId = $folderObject.attr('firstLinkedId');
    	  switch(objectType) {
	    	  case "article":{
	    		  if (!inSelectedBoxes && firstLinkedId != undefined && firstLinkedId.length > 0 ){
	    			  self._doOpen(firstLinkedId, false, false, $folderObject.attr('id'), !inSelectedBoxes, "");
	        		  self._openIds($folderObject);
	    		  } else {
	    			  self._doPlace(event.data.id, csEvent);
	    		  }
	    		  break;
	    	  }
			  case "txt":{
	    		  if (!inSelectedBoxes && firstLinkedId != undefined && firstLinkedId.length > 0 ){
	    			  self._doOpen(firstLinkedId, false, false, $folderObject.attr('id'), !inSelectedBoxes, "", event.data.id);
	        		  self._openIds($folderObject);
	    		  } else {
	    			  self._doPlace($folderObject.attr('id'), csEvent, undefined, event.data.id);
	    		  }
	    		  break;
	    	  }
	    	  case "story":
	    	  case "image":{
	    		  if ( inSelectedBoxes){
	    			  csEvent = "com.Miles33.GN4.placeStory";
	    		  }
	    		  self._doPlace(event.data.id, csEvent, $folderObject.attr('folderId'));
	    		  break;
	    	  }
	    	  case "extDocJumpPart":{
	    		  if (firstLinkedId != undefined && firstLinkedId.length > 0 ){
	    			  if ( !inSelectedBoxes) {
	    				  self._doOpen(firstLinkedId, false, false, "", false, $folderObject.attr('id'));
	    			  }
	    		  } else {
	    			  self._doPlace(event.data.id, csEvent);
	    		  }
	    		  break;
	    	  }
	    	  default:{
	    		  self._doPlace(event.data.id, csEvent);
	    		  break;
	    	  }
    	  }
  
      }).fail(function (xhr) {
    	  alert(parseException(xhr));
      });
};

IDSNCommandHandler.prototype.updateOffline = function(doc) {
	var updateEvent = new CSEvent("com.Miles33.GN4.updateExtDocOffline", csInterface.getApplicationID(), csInterface.getApplicationID());
	csInterface.dispatchEvent(updateEvent);
};