function PlaceDialog()
{
	this._create();
};

PlaceDialog.prototype._create = function(){
	var self = this;
	self._boxIds = [];
	self._itemIds = [];

	$('#placeBtPlace').click(function(){
		self._place();
	});
	$('#placeBtSkip').click(function(){
		if ( self._boxIds.length > 0 )
		{
			self._boxIds.splice(0, 1);
			self._next();
		}
		else
		{
			self._close();
		}
	});
	
	$('#placeDialog').on('hide.bs.modal', function(){
		self._select(self._selection);
		self._selection = undefined;		
	});

	$('#placeDialog').on('shown.bs.modal', function (e) {
		$('#placeArticle').scrollTop(0);
	})
};

PlaceDialog.prototype.open = function(data)
{
	var self = this;
	self._boxIds = [];
	self._itemIds = [];
	self._selection = undefined;

	var xmlDoc = $.parseXML(data);
	
	$(xmlDoc).find('boxes>box').each(function() {
		self._boxIds.push({id: $(this).attr('id'),
							type: $(this).attr('type')});
	});
	
	$(xmlDoc).find('items>*').each(function() {
		self._itemIds.push(this);
	});
	
	$('#placeDialog').modal('show');
	
	self._gotSelection = function(event) {
		csInterface.removeEventListener("com.Miles33.i4.script.selection", self._gotSelection);
		self._selection = event.data;
		self._next();
	};
	
    csInterface.addEventListener("com.Miles33.i4.script.selection", self._gotSelection);
	var extScript = "$._ext_IDSN.getSelection()";
	evalScript(extScript);
};

PlaceDialog.prototype._next = function()
{
	var self = this;
	if ( self._boxIds.length > 0 )
	{
		$('#placeArticle').empty();
		var ids=[];
		for(var i = 0; i < self._itemIds.length; i++ )
		{
			var item = self._itemIds[i];
			if (item.nodeName == self._boxIds[0].type )
			{
                ids.push($(item).attr('id').replace(/\D/g, ''));
			}
		}


		if ( ids.length == 0 )
		{
			self._boxIds.splice(0, 1);
			self._next();
		}
		else if ( ids.length == 1 )
		{
			var count = 0;
			for(var j = 0; j < self._boxIds.length; j++ )
			{
				if ( self._boxIds[j].type == self._boxIds[0].type )
				{
					count++;
				}
			}
			if ( count == 1 )
			{
                $('#placeArticle').append('<div class="selectable selected" data-id="' + ids[0] + '"></div>')
				self._place();
			}
			else
			{
                self._addSelectable(ids);
			}
		}
		else
		{
			self._addSelectable(ids);
		}
	}
	else
	{
		self._close();
	}
};

PlaceDialog.prototype._addSelectable = function(ids){
	var self = this;
    var url =
    $.ajax({
        type: "GET",
        url: getBaseURL() + 'do.ashx?cmd=feed&name=AdobeChooseImage&ids=' + ids.join(',')
    })
        .done(function (data) {
            $('#placeArticle').append(data);
            $('#placeArticle').find('.selectable').click(function() {
				$('#placeArticle').find('.selected').removeClass('selected');
				$( this ).addClass('selected');
			});
			$('#placeArticle').find('.selectable:first').addClass('selected');
            self._selectCurrentBox();
			$('#placeArticle').scrollTop(0);
        }).fail(function (xhr) {
			alert(parseException(xhr));
			self._close();
		});
};

PlaceDialog.prototype._getItem = function(){
	var self = this;
	var ret = null;
	var id = self._getSelectedItem();
	for(var i = 0; i < self._itemIds.length; i++ )
	{
		var item = self._itemIds[i];
		if (id == $(item).attr('id').replace(/\D/g, '') )
		{
			ret = (new XMLSerializer()).serializeToString(item);
			break;			
		}
	}
	return ret;
};

PlaceDialog.prototype._getSelectedItem = function(){
    return $('#placeArticle').find('.selectable.selected').data('id');
};

PlaceDialog.prototype._removeItem = function(){
	var self = this;
	var id = self._getSelectedItem();
	for(var i = 0; i < self._itemIds.length; i++ )
	{
		var item = self._itemIds[i];
		if (id == $(item).attr('id').replace(/\D/g, '') )
		{
			self._itemIds.splice(i, 1);
			break;			
		}
	}
};

PlaceDialog.prototype._place = function(){
	var self = this;
	var item = self._getItem();
	if ( item != null ){
		if ( self._boxIds.length > 0 ){
			var placeEvent = new CSEvent("com.Miles33.GN4.placeSingle", "APPLICATION", csInterface.getApplicationID(), csInterface.getApplicationID());
			placeEvent.data = "<gn4 boxId=\"" + self._boxIds[0].id + "\"><item>" + item + "</item></gn4>";
			csInterface.dispatchEvent(placeEvent);
			self._boxIds.splice(0, 1);
			self._removeItem();
			self._next();			
		} else {
			self._close();
		}
	}
};

PlaceDialog.prototype._selectCurrentBox = function(){
	var self = this;
	if ( self._boxIds.length > 0 ){
		self._select(self._boxIds[0].id);
	}
};

PlaceDialog.prototype._select = function(ids){
	if ( ids != undefined && ids != null){
		var extScript = '$._ext_IDSN.select("' + ids + '");';
		evalScript(extScript);
	}
};

PlaceDialog.prototype._close = function(){
	$('#placeArticle').scrollTop(0);
	$('#placeDialog').modal('hide');
};
