function SimpleCommandHandler()
{
	BaseCommandHandler.call(this);
	var extensionId = csInterface.getExtensionID();
	var appName = csInterface.hostEnvironment.appName;
	this.documents = [];
	if ( appName=="PHXS" || appName=="PHSP"){
	    evalScript('$._ext_PHXS.charIDToTypeID("Cls ")', function(res) {
	    	var CLOSE_INT = res.toString();
	    	evalScript('$._ext_PHXS.charIDToTypeID("quit")', function(res) {
	    		var QUIT_INT = res.toString();
	    		 var event = new CSEvent("com.adobe.PhotoshopRegisterEvent", "APPLICATION");
	    		    event.extensionId = extensionId;
	    		    

	    		    event.data = CLOSE_INT +  ", " + QUIT_INT;
	    		    csInterface.dispatchEvent(event);
		    });
	    });
	    
	    var eventPersistent = new CSEvent("com.adobe.PhotoshopPersistent", "APPLICATION");
	    eventPersistent.extensionId = extensionId;
	    csInterface.dispatchEvent(eventPersistent);
	    
	    
	    csInterface.addEventListener("PhotoshopCallback", this._PSCallback);	
    }
};

SimpleCommandHandler.prototype = Object.create(BaseCommandHandler.prototype);

SimpleCommandHandler.prototype.constructor = SimpleCommandHandler;

SimpleCommandHandler.prototype._PSCallback = function(csEvent) {
    var dataArray = csEvent.data.split(",");
    // send to JSX to convert typeIDs to stringIDs
    csInterface.evalScript('$._ext.convertTypeID(' + JSON.stringify(dataArray[0]) + ')', function(res) {
    	console.log('Data from the PSCallback: ' + res.toString());
    	if ( res == "close"){
    		commandHandler.CheckDocs();
    	}
    	
    });
};

SimpleCommandHandler.prototype.CheckDocs = function() {
	this.documents.forEach(function (entry) {
		if ( !entry.isConverting() ) {
			var extScript = "$._ext_" + csInterface.hostEnvironment.appName + ".isOpen('" + entry.getFileName() + "')";
			csInterface.evalScript(extScript, function (ret) {
				if (ret != "true") {
					entry.close();
				}
			});
		}else {
			console.log('CheckDoc called when converting is true');
		}
    });
};

SimpleCommandHandler.prototype.AfterSave = function(event) {
	xmlDoc = $.parseXML( event.data ),
	$xml = $( xmlDoc ),
	$url = $xml.find( "url" );
	var filename = $url.text();
	this.documents.forEach(function (entry) {
        var tempPath = entry.getFileName();
        if (tempPath && filename.length >= tempPath.length && filename.substr(filename.length - tempPath.length) == tempPath)	{
            entry.save();
            return false;
        }
	});
	console.log('Data from the JSX data: ' + $url.text());
};

SimpleCommandHandler.prototype.openFromI4 = function(ids, format) {
	var self = this;
	ids.forEach(function (entry) {
		self.openId(entry, format);
	});
};

SimpleCommandHandler.prototype.openId = function(id, format) {
	var isOpened = false;
	var doc = undefined;
	this.documents.forEach(function (entry) {
		if ( entry.getID() == id ){
			isOpened = entry.isOpen();
			if ( entry.getFileName() != null ){
				doc = entry;
			}
			return;
		}
	});
	
	if ( doc != undefined ){
		var extScript = "$._ext_" + csInterface.hostEnvironment.appName + ".isOpen('" + doc.getFileName() +"')";
		csInterface.evalScript(extScript, function(ret) {
			if (ret == "true") {
				alert(resourceBundle.AllreadyOpenErr);
			} else {
				doc.open(id, format);
			}
		});
	} else {
		if ( isOpened ){
			alert(resourceBundle.AllreadyOpenErr);		
		} else {
			doc = new GNDocument();
			if ( doc.open(id, format) )
			{
				this.documents.push(doc);
			}
		}
	}	
};

SimpleCommandHandler.prototype.convertFormat = function(id, format){
	var doc = undefined;
	this.documents.forEach(function (entry) {
		if ( entry.getID() == id ){
			isOpened = entry.isOpen();
			if ( entry.getFileName() != null ){
				doc = entry;
			}
			return;
		}
	});
	
	if ( doc != undefined ){
		doc.convert(format);
	}
};

SimpleCommandHandler.prototype.removeDocument = function(doc) {
	var index = this.documents.indexOf(doc);
	if ( index >= 0 ) {
		this.documents.splice(index, 1);
	}
};

SimpleCommandHandler.prototype.BeforeQuit = function(){
	this.CheckDocs();
	logout();
};
