function CacheData()
{
	this._mimeTypes = undefined;
	this._systemGuid = undefined;
	this._ticket = undefined;
}

CacheData.prototype.clear = function () {
	this._mimeTypes = undefined;
	this._systemGuid = undefined;
	this._ticket = undefined;
}

CacheData.prototype._requestMimeTypes = function () {
  var self = this;
  if (self._mimeTypes){
	return;
  } else {
	$.ajax({
	  url: getBaseURL() + 'do.ashx?cmd=getmimes',
      type: "Get",
	  async:false
	}).done(function(data){
		self._mimeTypes = [];
		$(data).find('MimeDesc').each(function(){
			self._mimeTypes.push({
				mime: $(this).attr('Mime').toLowerCase(),
				extension: $(this).attr('Extension'),
				macType: $(this).attr('MacType')
			})
		});
	});
  }
}, // _requestMimeTypes


CacheData.prototype._requestWho = function () {
  var self = this;
  if (self._systemGuid && self._ticket){
	return;
  } else {
	$.ajax({
		url: getBaseURL() + 'do.ashx?cmd=who',
		type: "Get",
		async:false
	}).done(function(data){
		var $result = $(data).find('LoginContext');
		if ( $result.length > 0 ){
			self._systemGuid = $result.attr('SystemGuid');
			self._ticket = $result.attr('Guid');
		}
	});
  }
}, // _requestMimeTypes
	
CacheData.prototype.getExtension = function(mimeType){
	var self = this;
	var ret;
	mimeType = mimeType.toLowerCase();
	self._requestMimeTypes();
	
	for(var i=0; i<self._mimeTypes.length;i++){
		if ( mimeType === self._mimeTypes[i].mime) {
			ret = self._mimeTypes[i].extension;
			break;
		}
	}
	if ( !ret || ret.length === 0 ){
		ret = mimeType.substr(mimeType.lastIndexOf("/")+1);
		if ( ret === "vdn.adobe.photoshop" ){
		  ret = "psd";
		} else if ( ret === "mpeg4" ){
		  ret = "mp4";
		}
		if ( ret && ret.length > 0){
			self._mimeTypes.push({
				mime: mimeType,
				extension: ret
			})
		}
	}
	return ret;
};

CacheData.prototype.getSystemGuid = function(){
	var self = this;
	if (!self._systemGuid){
		self._requestWho();
	}
	return self._systemGuid;
};

CacheData.prototype.setSystemGuid = function(guid){
	this._systemGuid = guid;
};

CacheData.prototype.getTicket = function(){
	var self = this;
	if (!self._ticket){
		self._requestWho();
	}
	return self._ticket;
};

CacheData.prototype.setTicket = function(guid){
	this._ticket = guid;
};


var cacheData = new CacheData();