function GNConnections() {
	this.connections = [];
};

GNConnections.prototype.getURL = function () {
	this._load();
	return $('#serversComboBox').val();
};

GNConnections.prototype.RequireLogin = function () {
	var ret = true;
	var self = this;
	if ( createSelected() ) {
		ret = requiresLoginSelected();
	} else {
		self._load();
		var url = $('#serversComboBox').val();
		self.connections.forEach(function (entry) {
			if ( entry.url == url) {
				ret = entry.RequireLogin == "true";
			}
		});
	}
	return ret;
};

GNConnections.prototype.exists = function (name, url) {
	var self = this;
	var ret = "";
	if( name.length == 0 ) {
		ret = resourceBundle.ConnectionBlankNameErr;
	} else if ( url.length == 0) {
		err = resourceBundle.ConnectionBlankServerErr;
	} else {
			self.connections.forEach(function (entry) {
				if ( entry.name == name ){
					ret = resourceBundle.ConnectionExistsErr;
					return;
				}
			});
	}
	return ret;
};

GNConnections.prototype.addURL = function (name, url, requiresLogin) {
	var self = this;
	var ret = self.exists(name, url);
	if (ret.length == 0 ) {
		self._add(name, url, "", "", "", requiresLogin, "false" );
		$('#serversComboBox').val(url);
		$('.gn4-create-new').show();
		$('#createConnectionCheckBox').prop('checked', false);
		createChange();
		self._save();
	}
	return ret;
};

GNConnections.prototype._load = function () {
	var self = this;
	var filepath = self._filepath();
	if ( filepath.length > 0){
		if (self.connections.length == 0){
			var result = window.cep.fs.readFile(filepath);
			if ( 0 == result.err){
				var $items = $(result.data).find('connection');
				var i=0;
				for(i=0;i<$items.length;i++){
					self._add($($items[i]).attr('Name'), $($items[i]).attr('Url'), $($items[i]).attr('UserName'), $($items[i]).attr('Password'), $($items[i]).attr('Domain'), $($items[i]).attr('RequireLogin'), $($items[i]).attr('SaveCredentials'));
				}
				$('#serversComboBox').trigger("change");
			}
		}
	}
	$('#createConnectionCheckBox').prop('checked', self.connections.length == 0);
	if ( self.connections.length > 0) {
		$('.gn4-create-new').show();
	}
};

GNConnections.prototype._save = function () {
	var self = this;
	var filepath = self._filepath();
	if ( filepath.length > 0){
		var data = '<?xml version="1.0" encoding="utf-8"?><UserConfig xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns="http://www.teradp.com/schemas/GN4/1/UserConfig.xsd"><Connections>';
		self.connections.forEach(function (entry) {
			data+='<Connection Name="';
			data+=entry.name;
			data+='" Url="';
			data+=entry.url;
			data+='"';
			if ( entry.UserName ){
				data+=' UserName="';
				data+=entry.UserName;
				data+='"';
			}
			if ( entry.Password ){
				data+=' Password="';
				data+=entry.Password;
				data+='"';
			}
			if ( entry.Domain ){
				data+=' Domain="';
				data+=entry.Domain;
				data+='"';
			}
			if ( entry.SaveCredentials ){
				data+=' SaveCredentials="';
				data+=entry.SaveCredentials;
				data+='"';
			}
			if ( entry.RequireLogin ){
				data+=' RequireLogin="';
				data+=entry.RequireLogin;
				data+='"';
			} else {
				data+=' RequireLogin="true"';
			}
			
			data+='/>';
		});
		data+='</Connections></UserConfig>';
		window.cep.fs.writeFile(filepath, data);
	}
};

GNConnections.prototype._makedir = function (path){
	var result = window.cep.fs.readdir(path);
	if ( 0 != result.err ){
		result = window.cep.fs.makedir(path);
	}
	return 0 == result.err;
};

GNConnections.prototype._filepath = function () {
	var self = this;
	var ret = "";
	var path = csInterface.getSystemPath(SystemPath.USER_DATA) + "/TeraDP";
	if ( self._makedir(path) )
	{
		path+="/GN4";
		if ( self._makedir(path) )
		{
			ret = path  + "/UserConfig.xml";
		}
	}
	return ret;
};

GNConnections.prototype._add = function (name, url, UserName, Password, Domain, RequireLogin, SaveCredentials)  {
	var self = this;
	self.connections.push({
		name: name,
		url: url,
		UserName: UserName,
		Password: Password,
		Domain: Domain,
		RequireLogin: RequireLogin,
		SaveCredentials: SaveCredentials
		
	});
	$('#serversComboBox').append('<option value="' + url + '">' + name + '</option>');
};
