function GNlogin()
{
	this.lastUploadTime = null;
	this.doClose = false;
};

GNlogin.prototype.login = function(username, password)
{
	var self = this;
	var doWho = false;
	var _load = function(){
		$('#i4frame').unbind('load', _load);
		self._checkLicense();
		if ( doWho ){
			self._doWho();
		}
	};
	
	if ( conn.RequireLogin() ) {
		var locale = csInterface.hostEnvironment.appUILocale.replace("_", "-");
		var appName = "Adobe CC:" + csInterface.hostEnvironment.appName;
		
		var offset = this._getTimeOffSet();
		
		var url = getBaseURL() + "do";
		if ( !username || username.length == 0)
		{
			url+="wa";
		}
		url+=".ashx?cmd=login";
		if (username && username.length > 0 ){
			url+= "&Name=" + username;
			url+= "&Pwd=" + password;
		}
		if (appName && appName.length > 0 ){
			url+= "&AppName=" + appName;
		}
		if (locale && locale.length > 0 ){
			url+= "&Language=" + locale;
		}
		if (offset && offset.length > 0 ){
			url+= "&TZOfs=" + offset;
		}
		
		$.ajax({
		   type: "GET",
	        url: url
	      })
	      .done(function (data) {
	    	  var $error = $(data).find('result error');
	    	  if ( $error.length > 0 ){
	    		  showURLForm();
	    		  alert($error.attr('message'));
	    	  } else {
				  $('#i4frame').bind('load', _load);
	    		  setFrameURL(getBaseURL() + "Login?adobecep=true&c=true&u=" + username);
	    		  self._setTicket(data);
	    	  }
	      })
	      .fail(function (xhr) {
	    	  showURLForm();
	    	  alert(parseException(xhr));
	      });
	} else {
		doWho = true;
		$('#i4frame').bind('load', _load);
		setFrameURL(getBaseURL());
		return;
	}
};

GNlogin.prototype._doWho = function(){
	var self = this;
	var url = getBaseURL() + "do.ashx?cmd=who";
	$.ajax({
	   type: "GET",
		url: url
	  })
	  .done(function (data) {
		  var $error = $(data).find('result error');
		  if ( $error.length > 0 ){
			  showURLForm();
			  alert($error.attr('message'));
		  } else {
			  self._setTicket(data);
		  }
	  });
};

GNlogin.prototype._setTicket = function(loginResult){
	var $result = $(loginResult).find('loginResult');
	var ticketStr = 'ticket';
	var userNameStr = 'userName';
	var systemGuid = '';
	
	if ( $result.length <= 0 ){
		$result = $(loginResult).find('LoginContext');
		ticketStr = 'Guid';
		serNameStr = 'UserName';
		if ( $result.length > 0 ){
			systemGuid = $result.attr('SystemGuid');
		}
	}else{
		systemGuid = $result.find('SystemGuid').text();
	}
	if ( $result.length > 0 ){
		var data = "<gn4 ticket=\"" + $result.attr(ticketStr) + "\" server=\"" + getBaseURL() + "\" userName=\"" + $result.attr(userNameStr) + "\" licenseType=\"" + licenseType().toString() + "\"></gn4>";
		var ticketEvent = new CSEvent("com.Miles33.GN4.ticket", "APPLICATION", csInterface.getApplicationID(), csInterface.getApplicationID());
		ticketEvent.data = data;
		csInterface.dispatchEvent(ticketEvent);
		if (cacheData){
			cacheData.setSystemGuid(systemGuid);
		}
	}
};

GNlogin.prototype._getTimeOffSet = function()
{
	var cur = new Date();
	var offset = "";
	var minutes = cur.getTimezoneOffset();
	if ( minutes < 0 )
	{
		minutes = minutes*-1;
	}
	else if ( minutes > 0 )
	{
		offset = "-";
	}
	
	var days = Math.floor(minutes/(60*24));
	minutes = minutes%(60*24);
	var hours = Math.floor(minutes/60);
	minutes = minutes%60;
	if ( days > 0 )
	{
		offset+=days.toString();
		offset+=".";
	}
	offset+=hours.toString();
	offset+=":";
	if ( minutes < 10 )
	{
		offset+="0";
	}
	offset+=minutes.toString();
	
	return offset;
};

GNlogin.prototype._checkLicense = function()
{
	var self = this;
	var date = new Date();
	if ( licenseType() > 0 ) {
      $.ajax({
        type: "POST",
        url: getBaseURL() + "api/License/Check",
        data: JSON.stringify({
          licenseType: licenseType(),
          requestTime: date.toISOString()
        }),
        contentType: "application/json"
      })
      .done(function (data) {
        $.ajax({
          type: "POST",
          url: getBaseURL() + "api/License/CheckHash",
          data: JSON.stringify({
            licenseType: licenseType(),
            requestTime: date.toISOString(),
            licenseHash: data
          }),
          contentType: "application/json"
        })
      .done(function (data) {
    	  setlicensed(true);
      })
      .fail(function (xhr) {
    	logout();
    	alert(parseException(xhr));
      });
      })
      .fail(function (xhr) {
        logout();
        alert(parseException(xhr));
      });
	} else {
		setlicensed(false);
	}
};