var licensed = false;
var commandHandler = null;
var conn = new GNConnections();
var ticketInfo = null;
var placeDialog = null;

var server = null;

function onLoaded() {
	doneLoad();
    var appName = csInterface.hostEnvironment.appName;
        
    if ( appName == "IDSN" ){
    	commandHandler = new IDSNCommandHandler();
    	csInterface.addEventListener("com.Miles33.GN4UI.PlaceForm", placeForm);
    	ticketInfo = new RequestTicket(gotTicket);
    } else if (appName =="AICY") {
    	commandHandler = new AICYCommandHandler();
    	ticketInfo = new RequestTicket(gotTicket);
    } else if (appName =="PPRO") {
    	commandHandler = new PPROCommandHandler();
    } else {
    	commandHandler = new SimpleCommandHandler();
    }
    
    csInterface.addEventListener("documentAfterSave", onEvent);
    csInterface.addEventListener("applicationBeforeQuit", onEvent);
    csInterface.addEventListener("documentAfterActivate", onEvent);
    csInterface.addEventListener("documentAfterDeactivate", onEvent);
    
    csInterface.addEventListener("com.Miles33.I4.open", openFromI4);
    csInterface.addEventListener("com.Miles33.I4.place", placeFromI4); 
	
	csInterface.addEventListener("com.Miles33.I4.convert", convertFormat);

    VulcanInterface.addMessageListener(VulcanMessage.TYPE_PREFIX + "com.Miles33.GN4UI.openItems", openItems);
              
    setFlyoutMenu(false);
    
    csInterface.addEventListener("com.adobe.csxs.events.flyoutMenuClicked", flyoutMenuClicked);
  
    $('#url').val(conn.getURL());
    
    $('#url').keypress(keyPressLoginFrom);
    $('#username').keypress(keyPressLoginFrom);
    $('#password').keypress(keyPressLoginFrom);
    
    createChange();
    
    $('#process').hide();
    
    if (appName != "AICY" && appName != "PPRO") {
	    server = require('net').createServer(function (socket) {
	    	console.log('client connected');
	        socket.on('data', function (data) {
	        	var command = data.toString();
	            console.log(command);
	            
	            if ( command.indexOf("GET") == 0 )
				{
					// GET /open?ids=34589 HTTP/1.1
					var start = command.indexOf("ids=") + 4;
					var end = command.indexOf("&", start);
					if ( end < 0 )
					{
						end = command.indexOf(" ", start);
					}
					var ids = command.substr(start, end-start).split(",");
					if ( ids.length == 0 || start == end)
					{
						socket.write(_getSocketResponse(resourceBundle.NoIDtoOpenKey));
					}
					else
					{				
						openIds(ids);
						socket.write(_getSocketResponse(""));
					}
				}
				else if ( data.length > 0 )
				{
					var startXML = command.indexOf("<gn4");
					var x = $(command.substr(startXML));
					if (x == null ){
						socket.write(_getSocketResponse(resourceBundle.NoIDtoOpenKey));
					}
					else{
						openXML($(command.substr(startXML)));
						socket.write(_getSocketResponse(""));
					}
				}
	                        
	        });
	    });
    }
}

function updatePanelMenu(Enabled){
	if (csInterface.getHostCapabilities().EXTENDED_PANEL_MENU){
		csInterface.updatePanelMenuItem(resourceBundle.LogoutKey, Enabled, false);
	}else{
		setFlyoutMenu(Enabled);
	}
}

function setFlyoutMenu(Enabled){
	var  flyoutMenu = 	'<Menu>' +
							'<MenuItem Id="I4Logout" Label="' + resourceBundle.LogoutKey + '" Enabled="' + (Enabled?'true':'false') + '" Checked="false"/>' +
						'</Menu>';
	csInterface.setPanelFlyoutMenu(flyoutMenu);
}

function _getSocketResponse(mess)
{
	var x;
	if ( mess.length > 0 )
	{
		x = "<error>" + mess + "</error>";
	}
	else
	{
		x = "<GN4/>";
	}
	
	var ret = "HTTP/1.1 200 OK\r\nCache-Control: no-cache, no-store\r\nPragma: no-cache\r\nContent-Length: ";
	ret+=Buffer.byteLength(x);
	ret+="\r\nContent-Type: application/xml; charset=utf-8\r\nExpires: -1\r\n\r\n";
	ret+=x;			
	return ret;
}

function keyPressLoginFrom(e){
  if (e.keyCode === ENTER_KEY) {
    OnClickI4Url();
    e.preventDefault();
  }
}

function onEvent(event) {
	console.log('Data from the JSX payload: ' + event.type);
	switch(event.type)
	{
		case 'documentAfterSave':
		{
			commandHandler.AfterSave(event);
			break;
		}
		case 'applicationBeforeQuit':
		{
			commandHandler.BeforeQuit();
			break;
		}
		case 'documentAfterActivate':
		case 'documentAfterDeactivate':
		{
			commandHandler.CheckDocs();
			break;
		}
	}
}

function openFromI4(event)
{
	var ids = [];
	if ( event.data.id ){
		ids.push(event.data.id);
	} else if (typeof event.data.ids === 'string')  {
		var temp = event.data.ids.trim();
		ids = temp.substr(1, temp.length-2).split(",");
	} else {
		ids = event.data.ids;
	}
	commandHandler.openFromI4(ids);
}

function placeFromI4(event)
{
	commandHandler.placeFromI4(event);
}

function convertFormat(event)
{
	var data = event.data;
	if ( typeof event.data === 'string' ||event.data instanceof String ){
		data = JSON.parse(event.data);
	}
	commandHandler.convertFormat(data.id, data.format);
}

function placeForm(event)
{
	if ( placeDialog == undefined || placeDialog == null ){
		placeDialog = new PlaceDialog();
	}
	
	placeDialog.open(event.data);
}

function openItems(event)
{
	var payload = VulcanInterface.getPayload(event);
	openXML($(payload).find('item'));
}

function openXML($items){
	var i=0;
	var type;
	var appName = csInterface.hostEnvironment.appName;
	var ids = [];
	for (i=0;i<$items.length; i++){
		type = $($items[i]).attr('type').toLowerCase();
		if ( (appName == "IDSN" || appName =="AICY") && type == "extDoc"){
			ids.push($($items[i]).attr('id'));
	    } else if ( ( appName=="PHXS" || appName=="PHSP" || appName=="ILST") && (type == "img" || type == "image") ){
			commandHandler.openFromI4([$($items[i]).attr('id')], $($items[i]).attr('format'));
		}
	}
	if ( ids.length > 0 ) {
		openIds(ids);
	}
}


function openIds(ids, format){
	commandHandler.openFromI4(ids, format);
}

function flyoutMenuClicked(event)
{
	if ( event.data.menuId == "I4Logout"){
		logout();
	}
	// event.data.menuId
	// event.data.menuName
}

function doLogout(evt){
	csInterface.removeEventListener("com.Miles33.i4.script.documentsOpen", doLogout);
	commandHandler.CheckDocs();
	if ( evt != undefined && evt.data != undefined && evt.data.toString().toLowerCase() == "true" ) {
		alert(resourceBundle.DocumentsOpenErr);
	}else{
		if ( licensed) {
			$.ajax({
		          type: "POST",
		          url: getBaseURL() + "api/License/Free",
		          data: JSON.stringify({
		            licenseType: licenseType()
		          }),
		          contentType: "application/json"
		        })
		        .done(function(data){
		        	licensed=false;
		        	doLogout();
		        })
		        .fail(function (xhr) {
		        	licensed=false;
		        	doLogout();
		      });
		} else {
			$.ajax({
			   type: "GET",
		        url: getBaseURL() + "logout"
		      })
		      .done(function (data) {
		    	  doneLogout();
		      })
		      .fail(function (xhr) {
		    	  doneLogout();
		    	  alert(parseException(xhr));
		      });
		}
	}	
}

function doneLogout(){
	cacheData.clear();
	showURLForm();
	if ( server ){
		server.close();
	}
	clearTicket();
}

function logout(){
	if (csInterface.hostEnvironment.appName =="PPRO") {
    	doLogout();
    } else {
	evalScript("$._ext.documentsClose()", function() {
		csInterface.addEventListener("com.Miles33.i4.script.documentsOpen", doLogout);
		var extScript = "$._ext.documentsOpen()";
		evalScript(extScript);
	});
	}
}

function clearTicket(){
	var ticketEvent = new CSEvent("com.Miles33.GN4.clearTicket", "APPLICATION", csInterface.getApplicationID(), csInterface.getApplicationID());
    csInterface.dispatchEvent(ticketEvent);
}

function showURLForm() {
	updatePanelMenu(false);
	$('#content').hide();
	$('#setURLForm').show();
	$('#process').hide();
	$('#i4frame').attr('src','about:blank');
	$('#loginBtn').prop( "disabled", false );
}

function getBaseURL() {
	var url = "";
	if (ticketInfo != undefined || ticketInfo != null ){
		url = ticketInfo.getURL();
	}
	if (url == undefined || url == null || url.length == 0 ){
		url = $('#url').val();
		if ( url && url.length > 1 && url.lastIndexOf("/") != url.length -1) {
			url = url + "/";
		}
		url = url + csInterface.hostEnvironment.appName + "/";
	}
	return url;
}

function setFrameURL(url){
    if ( url.length > 0  ) {
    	if ( createSelected() ){
			conn.addURL($('#createName').val(), $('#url').val(), requiresLoginSelected()?"true":"false");
		}
		updatePanelMenu(true);
    	if ( $('#i4frame').attr('src') != url )
		{
    		$('#i4frame').attr('src',url);
		}
    	$('#setURLForm').hide();
    	$('#content').show();
    }
    else {
    	showURLForm();
    }
}

function OnClickI4Url() {
	$('#process').show();
	doLogin();
}

function doLogin(){
	if (ticketInfo !=undefined && ticketInfo != null  ){
		ticketInfo.clean();
	}
	var err = "";
	if (createSelected()){
		err = conn.exists($('#createName').val(), $('#url').val());
	}
	if (err.length == 0) {
		var login = new GNlogin();
		login.login($('#username').val(), $('#password').val());
		$('#password').val("");
		$('#loginBtn').prop( "disabled", true );
	} else {
		$('#process').hide();
		alert(err);
		
	}
    
}

function setlicensed(val){
	licensed = val;
	getConfig();
	if ( val ) {
		commandHandler.updateOffline();
	}
}

function licenseType(){
	var ret=0;
	switch(csInterface.hostEnvironment.appName)
	{
		case 'IDSN':
		{
			//InDesignDesigner
			ret = 151;
			break;
		}
		case 'AICY':
		{
			// InCopyDesigner
			ret = 152;
			break;
		}
		case "PHXS":
		case "PHSP":
		{
			//PhotoshopDesigner
			ret = 153;
			break;
		}
		case "ILST":
		{
			//IllustratorDesigner
			ret = 154;
			break;
		}
	}
	return ret;
}

function serverChange()
{
	$('#url').val($('#serversComboBox').val());
	if ( conn.RequireLogin()) {
		$('.i4RequireLogin').show();
	} else {
		$('.i4RequireLogin').hide();
		if ( conn.connections.length == 1){
			OnClickI4Url();
		}
	}
}

function createSelected(){
	return $('#createConnectionCheckBox').is(":checked");
}

function createChange(){
	var selected = createSelected();
	if ( selected ){
		$('#url').removeAttr('readonly');
		$('#url').val("");
		$('#createName').val("");
		$('.createShow').show();
		$('.requiresLogin').show();
		$('.createHide').hide();
		$('.i4RequireLogin').show();
		requiresLoginChange();
	} else {
		$('#url').attr('readonly', 'readonly');
		$('#url').val(conn.getURL());
		$('.createShow').hide();
		$('.requiresLogin').hide();
		$('.createHide').show();
		serverChange();
	}
}

function requiresLoginSelected(){
	return $('#requiresLogin').is(":checked");
}

function requiresLoginChange(){
	if ( requiresLoginSelected() ) {
		$('.i4RequireLogin').show();
	} else {
		$('.i4RequireLogin').hide();
	}
}

function getConfig(){
	var configName = "";
	var defaultPort = 5678;
	switch(csInterface.hostEnvironment.appName)
	{
		case 'IDSN':
		{
			configName = "InDesignConfig";
			defaultPort = 5679;
			break;
		}
		case 'AICY':
		{
			configName = "InDesignConfig";
			defaultPort = 5679;
			break;
		}
		case "PHXS":
		case "PHSP":
		{
			configName = "PhotoshopConfig";
			defaultPort = 5678;
			break;
		}
		case "ILST":
		{
			configName = "IllustratorConfig";
			defaultPort = 5680;
			break;
		}
	}
	if ( configName && configName.length > 0 ){
		$.ajax({
			type: "GET",
			url: getBaseURL() + "do.ashx?cmd=config&name=" + configName
		  })
		  .done(function (data) {
			  var port = defaultPort;
			  var $items = $(data).find(configName);
			  if ( $items.length == 1 ){
				  
				  if ( $($items[0]).attr('port') !== undefined && $($items[0]).attr('port') != null ){
					  port = parseInt($($items[0]).attr('port'));
					  if (port === undefined || port == null || port == NaN || port < 0 ){
						  port = defaultPort;
					  }
				  }
			  }
			  if ( server ){
				  server.listen(port);
			  }
		  });
	}
}

function gotTicket(){
	$.ajax({
        type: "GET",
        url: getBaseURL() + "admin.ashx?cmd=restore&adobecep=true&ticket=" + ticketInfo.getTicket()
      })
      .done(function (data) {
    	  setFrameURL(getBaseURL());
    	  setlicensed(licenseType() > 0);
      })
      .fail(function (xhr) {
    	showURLForm();
      });
}