﻿$._ext_PPRO={
	kPProPrivateProjectMetadataURI: "http://ns.adobe.com/premierePrivateProjectMetaData/1.0/",
	fieldGN4ID: "GN4.ID",
	fieldGN4SystemGuid: "GN4.SystemGuid",
	fieldGN4ModifiedDate: "GN4.ModifiedDate",
	
    close: function(){
		if ( app.isDocumentOpen() )
		{
			app.project.closeDocument(0, 1);
		}
    },
	
	_getSep : function() {
		if (Folder.fs == 'Macintosh') {
			return '/';
		} else {
			return '\\';
		}
	},
	
	_loadAdobeXMPScript: function(){
		if (ExternalObject.AdobeXMPScript === undefined) {
			ExternalObject.AdobeXMPScript	= new ExternalObject('lib:AdobeXMPScript');
		}
		return (ExternalObject.AdobeXMPScript !== undefined);
	},
	
	_getIdFromItem:function(item){
		var self = this;
		if (item && self._loadAdobeXMPScript()){
			var projectMetadata	= item.getProjectMetadata();		
			var xmp	= new XMPMeta(projectMetadata);
			
			if ( xmp.doesPropertyExist(self.kPProPrivateProjectMetadataURI, self.fieldGN4ID) ){
                var gn4Id = xmp.getProperty(self.kPProPrivateProjectMetadataURI, self.fieldGN4ID);
				if (gn4Id ){
					return gn4Id.value;
				}
			}
		}
		return undefined;
	},
	
	_getModDateFromItem:function(item){
		var self = this;
		if (item && self._loadAdobeXMPScript()){
			var projectMetadata	= item.getProjectMetadata();		
			var xmp	= new XMPMeta(projectMetadata);
			
			if ( xmp.doesPropertyExist(self.kPProPrivateProjectMetadataURI, self.fieldGN4ModifiedDate) ){
                var gn4ModDate = xmp.getProperty(self.kPProPrivateProjectMetadataURI, self.fieldGN4ModifiedDate);
				if (gn4ModDate ){
					return gn4ModDate.value;
				}
			}
		}
		return '';
	},
		
	_getSystemGuidFromItem:function(item){
		var self = this;
		if (item && self._loadAdobeXMPScript()){
			var projectMetadata	= item.getProjectMetadata();		
			var xmp	= new XMPMeta(projectMetadata);
			
			if ( xmp.doesPropertyExist(self.kPProPrivateProjectMetadataURI, self.fieldGN4SystemGuid) ){
                var gn4Id = xmp.getProperty(self.kPProPrivateProjectMetadataURI, self.fieldGN4SystemGuid);
				if (gn4Id ){
					return gn4Id.value;
				}
			}
		}
		return undefined;
	},
	
	_iterateFromItem:function(item, func){
		var self = this;
		if (item){
			switch(item.type){
				case ProjectItemType.BIN:
				case ProjectItemType.ROOT:
				{
					for (var i = 0; i < item.children.numItems; i++) {
						if ( self._iterateFromItem(item.children[i], func) )
						{
							return true;
						}
					}
					break;
				}
				case ProjectItemType.FILE:
				case ProjectItemType.CLIP:
				{
					return func(item);
					break;
				}
				default:
				{
					break;
				}
				
			}
		}
	},
	
	getIds:function(systemGuid){
		var self = this;
		var ret = [];
		if (app.isDocumentOpen()) {
			self._iterateFromItem(app.project.rootItem,function(item){
				var guid = self._getSystemGuidFromItem(item);
				if (guid == systemGuid){
					var id = self._getIdFromItem(item);
					if ( id ){
						ret.push(id);
					}
				}
			});
		}
		return ret.join(',');
	},
	
	getModDate:function(gn4ID, systemGuid){
		var self = this;
		var ret;
		if (app.isDocumentOpen()) {
			self._iterateFromItem(app.project.rootItem,function(item){
				var guid = self._getSystemGuidFromItem(item);
				if (guid == systemGuid){
					var id = self._getIdFromItem(item);
					if ( id == gn4ID ){
						ret = self._getModDateFromItem(item);
						return true;
					}
				}
			});
		}
		return ret
	},
				
	addData:function(item, gn4ID, gn4ModDate, systemGuid){
		var self = this;
		if ( item ){
			if (self._loadAdobeXMPScript()) {
				var data = item.getProjectMetadata();

				var successfullyAdded	= app.project.addPropertyToProjectMetadataSchema(self.fieldGN4ID, "GN4 ID",	0);
				successfullyAdded	= app.project.addPropertyToProjectMetadataSchema(self.fieldGN4ModifiedDate, "GN4 Modified Date",	2);
				successfullyAdded	= app.project.addPropertyToProjectMetadataSchema(self.fieldGN4SystemGuid, "GN4 System Guid",	2);
				
				var xmp	= new XMPMeta(data);
				
				xmp.setProperty(self.kPProPrivateProjectMetadataURI, self.fieldGN4ID, 	gn4ID);
				xmp.setProperty(self.kPProPrivateProjectMetadataURI, self.fieldGN4ModifiedDate, 	gn4ModDate);
				xmp.setProperty(self.kPProPrivateProjectMetadataURI, self.fieldGN4SystemGuid, 	systemGuid);
				var array	= [];
				array[0]	= self.fieldGN4ID;
				array[1]	= self.fieldGN4ModifiedDate;
				array[2]	= self.fieldGN4SystemGuid;
				
				var str = xmp.serialize();
				item.setProjectMetadata(str, array);
			}
		}
	},

    importFile:function(path, gn4ID, gn4ModDate, systemGuid) {
		var self = this;
		if (app.isDocumentOpen()) {
			// New in 11.1; you can determine which bin will be targeted, before importing.
			var currentTargetBin;
            if ( app.project.getInsertionBin ){
                currentTargetBin = app.project.getInsertionBin();
               // if (currentTargetBin.nodeId === app.project.rootItem.nodeId){
                    // If we're here, then the target bin is the root of the project.
          //      }
            }
			var fileToImport = new File(path);
			if (fileToImport) {	
				var items = app.project.rootItem.findItemsMatchingMediaPath(fileToImport.fsName, 1);
			
				if ( items && items.length > 0 ){
					alert('Found items with same path "' + path + '"');
				}else {
					// We have an array of File objects; importFiles() takes an array of paths.
					var importThese = [];
					if (importThese){
						importThese[0] = fileToImport.fsName;
						if ( app.project.importFiles(importThese, 
												1,				// suppress warnings 
												currentTargetBin,
												0) ){				// import as numbered stills
							items = app.project.rootItem.findItemsMatchingMediaPath(fileToImport.fsName, 1);
							
							if ( items && items.length > 0 ){
								for(var i=0;i<items.length;i++){
									self.addData(items[i], gn4ID, gn4ModDate, systemGuid);
								}
							}
						}
					}
				}
			}
		}
	},
	
	_updateItem:function(item, file, gn4ID, gn4ModDate, systemGuid){
		var self = this;
		if ( item ){
			var guid = self._getSystemGuidFromItem(item);
			if (guid == systemGuid){
				var id = self._getIdFromItem(item);
				if ( id == gn4ID ){
					if (item.getMediaPath() == file.fsName ){
						item.refreshMedia();
						self.addData(item, gn4ID, gn4ModDate, systemGuid);
					} else {
						var move = true;
						if ( item.canChangeMediaPath()){
							if ( item.changeMediaPath(file.fsName))
							{
								move = false;
							}
						} 
						if ( move ){
							alert("error updating " + gn4ID);
						} else {
							item.refreshMedia();
							self.addData(item, gn4ID, gn4ModDate, systemGuid);
						}
					}
				}
			}
		}
	},
	
	updateItem:function(path, gn4ID, gn4ModDate, systemGuid){
		var self = this;
		if (app.isDocumentOpen()) {
			var fileToImport = new File(path);
			if (fileToImport) {	
				var items = app.project.rootItem.findItemsMatchingMediaPath(fileToImport.fsName, 1);
				if ( items && items.length > 0 ){
					for(var i=0;i<items.length;i++){
						self._updateItem(items[0], fileToImport, gn4ID, gn4ModDate, systemGuid);
					}
				} else {
					self._iterateFromItem(app.project.rootItem,function(item){
						self._updateItem(item, fileToImport, gn4ID, gn4ModDate, systemGuid);
					});
				}
			}
		}
	},

	getProjectFilePath: function () {
		var r = "";
		if (app.isDocumentOpen()) {
            r = app.project.path;
		}
		return r;
	},
	
	keepPanelLoaded : function() {
		if ( app.setExtensionPersistent){
			app.setExtensionPersistent("com.Miles33.I4.main", 1); // 0, while testing (to enable rapid reload); 1 for "Never unload me, even when not visible."
		}
	},
	
	render : function(outputPresetPath, outputFolderPath) {
		var ret = "";
		var self = this;
		app.enableQE();
		var activeSequence = qe.project.getActiveSequence();	// we use a QE DOM function, to determine the output extension.
		if (activeSequence)	{
			app.encoder.launchEncoder();	// This can take a while; let's get the ball rolling.

			var projPath	= new File(app.project.path);
			
			var outputPath = new File(outputFolderPath);
			
			if ((outputPath) && projPath.exists){
				var outPreset		= new File(outputPresetPath);
				if (outPreset.exists === true){
					var outputFormatExtension		=	activeSequence.getExportFileExtension(outPreset.fsName);
					if (outputFormatExtension){
						var outputFilename	= 	activeSequence.name + '.' + outputFormatExtension;

						var fullPathToFile	= 	outputPath.fsName 	+ 
												self._getSep() 	+ 
												activeSequence.name + 
												"." + 
												outputFormatExtension;			

						var outFileTest = new File(fullPathToFile);

						if (outFileTest.exists){
							var destroyExisting	= confirm("A file with that name already exists; overwrite?", false, "Are you sure...?");
							if (destroyExisting){
								outFileTest.remove();
								outFileTest.close();
							}
						}

						app.encoder.bind('onEncoderJobComplete',	$._ext_PPRO.onEncoderJobComplete);
						app.encoder.bind('onEncoderJobError', 		$._ext_PPRO.onEncoderJobError);
						app.encoder.bind('onEncoderJobQueued', 		$._ext_PPRO.onEncoderJobQueued);
						app.encoder.bind('onEncoderJobCanceled',	$._ext_PPRO.onEncoderJobCanceled);


						// use these 0 or 1 settings to disable some/all metadata creation.

						app.encoder.setSidecarXMPEnabled(0);
						app.encoder.setEmbeddedXMPEnabled(0);
					
						ret="JobID|" + app.encoder.encodeSequence(	app.project.activeSequence,
																fullPathToFile,
																outPreset.fsName,
																app.encoder.ENCODE_ENTIRE, 
																1);	   // Remove from queue upon successful completion?					
						
						outPreset.close();
					}
				} else {
					ret = "Error:Could not find output preset.";
				}
			} else {
				ret = "Error:Could not find/create output path.";
			}
			projPath.close();
		} else {
			ret = "Error:No active sequence.";
		}
		return ret;
	},
	
	onEncoderJobComplete : function (jobID, outputFilePath) {
		try {
	    	var xLib = new ExternalObject("lib:\PlugPlugExternalObject");
	    	if (xLib) {
			    var eventObj = new CSXSEvent(); 
			    eventObj.type = "com.Miles33.i4.render.done";
			    eventObj.data = jobID + "|" + outputFilePath;
			    eventObj.dispatch();
			}
		} catch (e) {
		    alert(e);
		}
	},

	onEncoderJobError : function (jobID, errorMessage) {
		try {
	    	var xLib = new ExternalObject("lib:\PlugPlugExternalObject");
	    	if (xLib) {
			    var eventObj = new CSXSEvent(); 
			    eventObj.type = "com.Miles33.i4.render.error";
			    eventObj.data = jobID + "|" + errorMessage;
			    eventObj.dispatch();
			}
		} catch (e) {
		    alert(e);
		}
	},
	
	onEncoderJobQueued : function (jobID) {
		app.encoder.startBatch();
	},

	onEncoderJobCanceled : function (jobID) {
		$._ext_PPRO.onEncoderJobError(jobID, 'Render Job was cancelled.');
	},
};